Subject: [apps-discuss] 'Base' and 'Content-Base' header fields

From: Mykyta Yevstifeyev <[email-masked]>
Date: Mon, 29 Aug 2011 18:55:18 +0300

Hello all,

RFC 1808 proposed the 'Base' header field to be used in HTTP/mail 
messages.  This header field was intended to be used for establishing 
the base URI when resolving relative URIs; what RFC 1808 says is:

>    Messages are considered to be composite documents.  The base URL of a
>    message can be specified within the message headers (or equivalent
>    tagged metainformation) of the message.  For protocols that make use
>    of message headers like those described in RFC 822 [5], we recommend
>    that the format of this header be:
>
>       base-header  = "Base" ":" "<URL:" absoluteURL ">"
>
>    where "Base" is case-insensitive and any whitespace (including that
>    used for line folding) inside the angle brackets is ignored.

However, this disappeared from RFC 2396.  RFC 2110, though, introduced 
'Content-Base' header field for the similar purpose, but RFC 2557, which 
obsoleted 2110, said that this header field was removed from the new 
version of MHTML.  Now 'Content-Base' for MIME is listed with reference 
to RFC 4021, which referred to then-obsoleted RFC 2110.

RFC 4229 registered 'Content-Base' for HTTP, referring to RFC 2068.  
Nevertheless RFC 2616 didn't specify 'Content-Base' header field as 
well, so the factual spec is obsolete RFC 2068.

So, you see, 'Content-Base' is in the rather uncertain state, and no 
clear definition is available.  (This reminds me of 'Link' header field, 
which was in rather the same state.)  So, is there enough support to 
undertake the effort to define 'Content-Base' field properly?

Mykyta Yevstifeyev

---

From: Frank Ellermann <[email-masked]>
Date: Mon, 29 Aug 2011 20:24:20 +0200

On 29 August 2011 17:55, Mykyta Yevstifeyev wrote:

> So, is there enough support to undertake the effort to define
> 'Content-Base' field properly?

>From my POV all "base URI" concepts do not work as they should,
because fragments are interpreted w.r.t. this base, instead of
"the document at hand".  If fragments in "offline" documents,
notably file: URIs, don't work as expected with a http: base
in an "offline" state, then a base for online resources (CSS,
icons, banners, etc.) doesn't help.  I'm not sure that this is
also relevant for Content-Base and MIME.

Apparently RFC 2557 says that the Content-Base in RFC 2110 is
obsolete, and RFC 4021 forgot to mention that detail when the
header field registry was established.

Let's just fix the IANA registry, Content-Base is a "MUST NOT
generate" (RFC 2557 section 12).  For the former "Base" header
field I sent a review request to ietf-message-headers@ietf, it
just has to be registered as obsoleted by RFC 2110.

-Frank

---

From: "Murray S. Kucherawy" <[email-masked]>
Date: Mon, 29 Aug 2011 11:45:12 -0700

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] On Behalf Of Mykyta Yevstifeyev
> Sent: Monday, August 29, 2011 8:55 AM
> To: Apps-discuss list
> Subject: [apps-discuss] 'Base' and 'Content-Base' header fields
> 

Does anything actually use this, or is it just something that got dropped in the specs along the way?

Or perhaps more simply: What problem are you trying to solve?

If it's not in widespread use, I imagine there's no pressing need to "fix" it.

-MSK

---

From: SM <[email-masked]>
Date: Mon, 29 Aug 2011 11:55:50 -0700

Hi Frank,
>just has to be registered as obsoleted by RFC 2110.

It's easier to do that than to have yet another RFC.

Regards,
-sm

---

From: Frank Ellermann <[email-masked]>
Date: Mon, 29 Aug 2011 22:05:00 +0200

On 29 August 2011 20:55, SM wrote:

>> Let's just fix the IANA registry
[...]
> It's easier to do that than to have yet another RFC.

Yes, done, there are now three registration templates
(Base: mime, Content-Base: mime, Content-Base: http)
for review on the ietf-message-headers@ietf list.  If
that is not as it should be for the HTTP header field
please fix/forward/discuss/... it.

-Frank

---

From: Mark Nottingham <[email-masked]>
Date: Tue, 30 Aug 2011 09:21:15 +1000

On 30/08/2011, at 1:55 AM, Mykyta Yevstifeyev wrote:

> So, you see, 'Content-Base' is in the rather uncertain state, and no clear definition is available.  (This reminds me of 'Link' header field, which was in rather the same state.)  So, is there enough support to undertake the effort to define 'Content-Base' field properly?

HTTP doesn't really use Content-Base; we have Content-Location. 

Clarifying the registry entry seems like the right thing to do...

Cheers,

--
Mark Nottingham   http://www.mnot.net/